package com.ekexiu.portal.question;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.*;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@DAO
public interface QuestionDao {

	@Insert
	int insert(Connection con, Question qen) throws SQLException;

	@DeleteWith
	@From(QetKeyWord.class)
	int deleteKeys(Connection con, String id) throws SQLException;

	@Insert
	@Batch
	int[] insert(Connection con, QetKeyWord[] kws) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	List<Question> query(Connection con, @Nullable String state, @Nullable String uid, @LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	@Where(" STATE='1'")
	List<Question> watch(Connection con,
			@SqlColumn(handlerClass = StringHandler.class, value = {
					" ID IN (SELECT WATCH_OBJECT FROM WATCH WHERE WATCH_TYPE='8' AND PROFESSOR_ID=?)" }) String uid,
			@LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;

	@SelectOne
	@Nullable
	Question query(Connection con, String id) throws SQLException;
	
	@SelectOne
	@Nullable
	Answer queryAnswer(Connection con,String id)throws SQLException;

	@SelectList
	List<Question> query(Connection con, @In String[] id) throws SQLException;
	
	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	@Where("QID IN(SELECT ID FROM QUESTION WHERE STATE='1') AND STATE='1'")
	List<Answer> answer(Connection con,@LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	@Where("QID IN(SELECT ID FROM QUESTION WHERE STATE='1') AND STATE='1'")
	List<Answer> answerSelf(Connection con, String uid, @LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	@Where("QID IN(SELECT ID FROM QUESTION WHERE STATE='1') AND STATE='1'")
	List<Answer> watchAnswer(Connection con,
			@SqlColumn(handlerClass = StringHandler.class, value = {
					" ID IN (SELECT WATCH_OBJECT FROM WATCH WHERE WATCH_TYPE='9' AND PROFESSOR_ID=?)" }) String uid,
			@LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ID ASC")
	List<Answer> byQes(Connection con, String qid, @LtEq String createTime, @GreaterThan String id, int rows) throws SQLException;
	@LimitQuery
	@OrderBy("ORDER BY SCORE DESC,ID ASC")
	List<SortedAnswwer> byQes(Connection con, String qid, @SqlColumn(handlerClass = IntHandler.class, value = { "10000 * AGREE / BALLOT <= ?  " }) int score, @GreaterThan String id, int rows) throws SQLException;

	@Insert
	int insert(Connection con,AnswerAgreeRec aar)throws SQLException;
	@UpdateWith
	@From(AnswerAgreeRec.class)
	@Where("FLAG<>'1'")
	@SetSentence("FLAG='1'")
	int agree(Connection con,String uid,String aid)throws SQLException;
	@UpdateWith
	@From(AnswerAgreeRec.class)
	@Where("FLAG='1'")
	@SetSentence("FLAG='0'")
	int unAgree(Connection con,String uid,String aid)throws SQLException;
	
	@UpdateWith
	@From(Answer.class)
	int update(Connection con,String id, @Set( " = AGREE +?" ) long agree,@Set("=BALLOT+?") long ballot)throws SQLException;
	
	
	@Insert
	int insert(Connection con, Answer answer) throws SQLException;

	@UpdateWith
	@From(Answer.class)
	@IncludeFixSet
	int updateAnswer(Connection con, String id, @Set String cnt) throws SQLException;
}
