package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Collections;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.AfterCommit;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.exception.JfwBaseException;

import com.ekexiu.portal.dao.PatentAgreeDao;
import com.ekexiu.portal.dao.PatentAuthorDao;
import com.ekexiu.portal.dao.PpatentDao;
import com.ekexiu.portal.notify.NotifyService;
import com.ekexiu.portal.notify.NotifyType;
import com.ekexiu.portal.po.PatentAgree;
import com.ekexiu.portal.po.PatentAuthor;
import com.ekexiu.portal.po.Ppatent;
import com.ekexiu.portal.pojo.AssedPatent;

@Path("/ppatent")
public class PpatentServcie {

	@Autowrie
	private PpatentDao ppatentDao;
	@Autowrie
	private PatentAuthorDao patentAuthorDao;
	
	@Autowrie
	private KeyWordService keyWordService;
	
	@Autowrie
	private PatentAgreeDao patentAgreeDao;
	
	@Autowrie
	private NotifyService notifyService;
	
	

	public NotifyService getNotifyService() {
		return notifyService;
	}

	public void setNotifyService(NotifyService notifyService) {
		this.notifyService = notifyService;
	}

	public PatentAgreeDao getPatentAgreeDao() {
		return patentAgreeDao;
	}

	public void setPatentAgreeDao(PatentAgreeDao patentAgreeDao) {
		this.patentAgreeDao = patentAgreeDao;
	}

	public KeyWordService getKeyWordService() {
		return keyWordService;
	}

	public void setKeyWordService(KeyWordService keyWordService) {
		this.keyWordService = keyWordService;
	}
	
	public PpatentDao getPpatentDao() {
		return ppatentDao;
	}



	public void setPpatentDao(PpatentDao ppatentDao) {
		this.ppatentDao = ppatentDao;
	}



	public PatentAuthorDao getpatentAuthorDao() {
		return patentAuthorDao;
	}



	public void setPatentAuthorDao(PatentAuthorDao paperAuthorDao) {
		this.patentAuthorDao = paperAuthorDao;
	}



	@Get
	@Path("/qo")
	public Ppatent query(@JdbcConn Connection con,String id)throws SQLException{
		return this.ppatentDao.query(con, id);
	}
	@Get
	@Path("/qm")
	public List<Ppatent> query(@JdbcConn Connection con,String[] id)throws SQLException{
		return this.ppatentDao.query(con, id);
	}
	
	@Get
	@Path("/byProfessor")
	public PageQueryResult<AssedPatent> queryByProfessor(@JdbcConn Connection con,String id,@Nullable String name,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		if(name == null ){
			name ="%";
		}else{
			name ="%"+name+"%";
		}
		return this.ppatentDao.pageQueryWithProfessor(con, id, name, pageSize, pageNo);
	}
	@Get
	@Path("/byAuthor")
	public PageQueryResult<AssedPatent> queryByAuthor(@JdbcConn Connection con,String author,String id,@Nullable String name,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		if(name == null ){
			name ="%";
		}else{
			name ="%"+name+"%";
		}
		return this.ppatentDao.pageQueryWithAuthor(con, author,id, name, pageSize, pageNo);
	}
	
	@Get
	@Path("/authors")
	public List<PatentAuthor> queryAuthors(@JdbcConn Connection con,String id)throws SQLException{
		return this.patentAuthorDao.query(con,id);
	}
	@Get
	@Path("/pq")
	public PageQueryResult<Ppatent> pageQuery(@JdbcConn Connection con, @Nullable String qw, @DefaultValue("20") int pageSize, @DefaultValue("1") int pageNo)
			throws SQLException {
		return null == qw ? this.ppatentDao.query(con, pageSize, pageNo) : this.ppatentDao.query(con, "%" + qw + "%", pageSize, pageNo);
	}
	/**
	 * 
	 * @param con
	 * @param uid 专家ID(用户ID) 
	 * @param id  论文ID
	 * @param author 作者名称
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/ass")
	public int ass(@JdbcConn(true) Connection con,String uid,String id,String author)throws SQLException{
		return this.patentAuthorDao.update(con, id, uid, author);
	}
	/**
	 * 
	 * @param con
	 * @param uid 专家ID(用户ID) 
	 * @param id  论文ID
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/cAss")
	public int cAss(@JdbcConn(true) Connection con,String uid,String id)throws SQLException{
		return this.patentAuthorDao.update(con, id, uid);
	}	
	
	@Post
	@Path("/incPageViews")
	public void incPageViews(@JdbcConn(true) Connection con,String id)throws SQLException{
		this.ppatentDao.incPageViews(con, id);
	}
	
	@Post
	@Path("/kw")
	public void update(@JdbcConn(true) Connection con,String id,@Nullable String keywords)throws SQLException{
		this.ppatentDao.update(con, id, keywords);
		this.keyWordService.refreshPatent(con, id, KeyWordService.splitKeyWord(keywords));		
	}
	@Get
	@Path("/byShareId")
	public Ppatent query(@JdbcConn Connection con,long id)throws SQLException{
		return this.ppatentDao.query(con,id);
	}
	@Get
	@Path("/ralatePatents")
	public List<Ppatent> ralatePatents(@JdbcConn Connection con,String patentId,@DefaultValue("5") int rows)throws SQLException{
		String[] ids = this.ppatentDao.queryPatentIdWithSameKeyWord(con, patentId, rows);
		if(ids!=null){
			return this.ppatentDao.query(con,ids);
		}
		return Collections.<Ppatent>emptyList();
	}
	
	@Post
	@Path("/agree")
	public void agree(@JdbcConn(true) Connection con,String id,String uid,String uname,@AfterCommit List<Runnable> runs)throws SQLException, JfwBaseException{
		Ppatent p = ppatentDao.query(con, id);
		if(p==null){
			throw new JfwBaseException(50000, "patent["+id+"] not found");
		}
		PatentAgree pa = new PatentAgree();
		pa.setOpId(uid);
		pa.setPatentId(id);
		this.patentAgreeDao.insert(con, pa);		
		List<PatentAuthor> authors = this.patentAuthorDao.query(con,id);
		for(PatentAuthor pau:authors){
			if(!pau.getProfessorId().startsWith("#")){
				this.notifyService.notify(con,pau.getProfessorId(), uid, uname, id,p.getName(), NotifyType.AGREE_PATENT, runs);
			}
		}
	}
	
//	@Post
//	@Path("/unAgree")
//	public void unAgree(@JdbcConn(true) Connection con,String id,String uid)throws SQLException{
//		this.patentAgreeDao.delete(con,uid, id);
//	}
	
	@Get
	@Path("/agree")
	public boolean hasAgree(@JdbcConn(false) Connection con,String id,String uid)throws SQLException{
		return null!= this.patentAgreeDao.query(con,uid, id);
	}
	@Get
	@Path("/agreeCount")
	public int agreeCount(@JdbcConn(false) Connection con,String id)throws SQLException{
		return this.patentAgreeDao.query(con,id);
	}
	
	@Get
	@Path("/assPatents")
	public List<Ppatent> assPatent(@JdbcConn Connection con,String[] kws,@DefaultValue("5") int rows)throws SQLException{
		if(kws==null || kws.length==0) return Collections.<Ppatent>emptyList();		
		String[] ids = this.ppatentDao.queryPatentIdWithKeyWord(con, kws, rows);
		if(ids==null || ids.length==0) return Collections.<Ppatent>emptyList();
		return this.ppatentDao.query(con, ids);		
	}
	
}
